=== widgets/qt4/CMakeLists.txt ===
include(GenerateExportHeader)

if(enable-qt4)
	include(../../cmake-qt4.txt)
	set(MGL_QT4_FILES ../qt.cpp ../../include/mgl2/qt.h ../../include/mgl2/qmathgl.h)
	mgl_add_lib(qt4 ${MGL_QT4_FILES})
	target_link_libraries(mgl-qt4 mgl ${MGL_QT4_LIBS})
	target_link_libraries(mgl-qt4-static mgl-static ${MGL_QT4_LIBS})
	if(enable-qt4asqt)
		mgl_add_lib(qt ${MGL_QT4_FILES})
		target_link_libraries(mgl-qt mgl ${MGL_QT4_LIBS})
		target_link_libraries(mgl-qt-static mgl-static ${MGL_QT4_LIBS})
	endif(enable-qt4asqt)

	if(MGL_HAVE_FLTK AND NOT enable-qt5)
		mgl_add_lib(wnd ${MGL_QT4_FILES} ../fltk.cpp ../../include/mgl2/fltk.h ../image.cpp ../image.h)
		target_include_directories(mgl-wnd SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
		target_include_directories(mgl-wnd-static SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
		target_link_libraries(mgl-wnd mgl ${FLTK_LIBRARIES} ${MGL_QT4_LIBS})
		target_link_libraries(mgl-wnd-static mgl-static ${FLTK_LIBRARIES} ${MGL_QT4_LIBS})
	endif(MGL_HAVE_FLTK AND  NOT enable-qt5)
endif(enable-qt4)
