=== debian/changelog ===
mathgl (2.4-1) unstable; urgency=medium

  * New upstream release
  * Library version numbers updated to soname 7.4.1->7.5.0
  * Standards-Version: 4.0.0  
  * Set libmgl-data as M-A: foreign
  * Added myself as uploader  

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Jun 2017 09:27:37 +0100

mathgl (2.3.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix from Bas  Couwenberg for HDF5 build issue. Closes: #835680

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 12 Sep 2016 10:41:06 +0100
